import pygame
import os
import math
from gameObject import GameObject


################################################################################
# CONSTANTS
################################################################################

GRAV_ACC = 0.15 #acceleration caused by gravity

#Max x and y speeds
MAX_XSPEED = 5
MAX_YSPEED = 7.5

FRICTION = 0.9 #horizontal friction

MAX_XACCEL = .5
MAX_YACCEL = .5

class Player(GameObject):

	def __init__(self,gameScene,x,y):
		GameObject.__init__(self,gameScene,x,y,16,16)
		
		self.accelX = 0
		self.accelY = 0
		self.velX = 0.0
		self.velY = 0.0
		self.jumping = 0
		self.jumpingBool = 0
		self.rect = pygame.Rect(x,y,16,30)
				
		self.gE = gameScene.gameEngine
		
		self.imgRight = self.gE.resourceManager.getImage(os.path.join("mikenewright"))
		self.imgLeft = self.gE.resourceManager.getImage(os.path.join("mikenewleft"))
		self.img = self.imgRight

	
	#def particleTrail(self, x, y, colour):
		
		
	def draw(self):
		self.gE.screen.blit(self.img,(self.rect.x,self.rect.y-15))
	
	def update(self):
		keys = pygame.key.get_pressed()
		
		#apply gravity
		self.accelY += GRAV_ACC
		
		#apply friction
		self.velX *= FRICTION
		
		#move left and right  
		if keys[pygame.K_d] or keys[pygame.K_KP6]:
			self.accelX += .2
		if keys[pygame.K_a] or keys[pygame.K_KP4]:
			self.accelX -= .2
		if not keys[pygame.K_d] and not keys[pygame.K_a]:
			self.accelX = 0
		
		
		
		#jumping 
		if keys[pygame.K_SPACE] and not self.jumping and self.jumpingBool:
			self.accelY = -5
			self.velY = -5.0
			self.jumping = 1
			self.jumpingBool = 0
		
		if not keys[pygame.K_KP9]:
			self.jumpingBool =  1
			#this.jumping = true
		
		#accelleration caps
		if self.accelX > 0:
			if self.accelX > MAX_XACCEL:
				self.accelX = MAX_XACCEL
		elif self.accelX < 0:
			if self.accelX < -MAX_XACCEL:
				self.accelX = -MAX_XACCEL
				
		if self.accelY > 0:
			if self.accelY > MAX_YACCEL:
				self.accelY = MAX_YACCEL
		elif self.accelY < 0:
			if self.accelY < -MAX_YACCEL:
				self.accelY = -MAX_YACCEL
		
		#adding acceleration to velocity	
		self.velX += self.accelX
		self.velY += self.accelY
		
		
		
		#velocity caps
		if self.velX > 0:
			if self.velX > MAX_XSPEED:
				self.velX = MAX_XSPEED
		elif self.velX < 0:
			if self.velX < -MAX_XSPEED:
				self.velX = -MAX_XSPEED
				
		if self.velY > 0:
			if self.velY > MAX_YSPEED:
				self.velY = MAX_YSPEED
		elif self.velY < 0:
			if self.velY < -MAX_YSPEED:
				self.velY = -MAX_YSPEED
			
		if self.velX < 0:
			self.img = self.imgLeft
		if self.velX > 0:
			self.img = self.imgRight
		#moving position on screen with velocity

		if self.velX < 0.01 and self.velX > 0.0:
			self.velX = 0
		if self.velX > -.01 and self.velX < 0.0:
			self.velX = 0
			

		self.rect.x += round(self.velX)
		self.rect.y += round(self.velY)
	
