import pygame
import os
import math
import random


class FractionColour:
	def __init__(self, numerator, denominator, colour):
		self.numerator = numerator
		self.denominator = denominator
		self.colour = colour

class ProblemsManager:
	def __init__(self):
		#makes the arrays. First number is number of paintbuckets, second number is number of doors
		self.problems2_3 = []
		self.problems3_3 = []
		
		self.make2_3Problems()
		#self.make3_3Problems()
		
	
	def make2_3Problems(self):
	
		#make questions/answers
		#1
		q1FractionColour1 = FractionColour(2, 3, (0, 255, 0))
		q1FractionColour2 = FractionColour(1, 6, (255, 0, 0))

		a1FractionColour1 = FractionColour(3, 9, (255, 255, 255))
		a1FractionColour2 = FractionColour(5, 6, (255, 255, 255))
		a1FractionColour3 = FractionColour(3, 6, (255, 255, 255))
		
		problems1 = Problems([q1FractionColour1, q1FractionColour2], [a1FractionColour1, a1FractionColour2, a1FractionColour3], 1)
		self.problems2_3.append(problems1)
		
		#2
		q2FractionColour1 = FractionColour(1, 3, (0, 0, 255))
		q2FractionColour2 = FractionColour(4, 9, (255, 0, 0))
		
		a2FractionColour1 = FractionColour(7, 9, (255, 0, 0))
		a2FractionColour2 = FractionColour(7, 12, (0, 0, 255))
		a2FractionColour3 = FractionColour(5, 12, (255, 255, 255))
		
		problems2 = Problems([q2FractionColour1, q2FractionColour2], [a2FractionColour1, a2FractionColour2, a2FractionColour3], 0)
		self.problems2_3.append(problems2)
		#3
		q3FractionColour1 = FractionColour(2, 5, (0, 255, 0))
		q3FractionColour2 = FractionColour(1, 10, (255, 0, 255))
		
		a3FractionColour1 = FractionColour(3, 5, (255, 255, 255))
		a3FractionColour2 = FractionColour(3, 10, (255, 255, 255))
		a3FractionColour3 = FractionColour(5, 10, (255, 255, 255))
		
		problems3 = Problems([q3FractionColour1, q3FractionColour2], [a3FractionColour1, a3FractionColour2, a3FractionColour3], 2)
		self.problems2_3.append(problems3)
		#4
		q4FractionColour1 = FractionColour(5, 8, (255, 255, 0))
		q4FractionColour2 = FractionColour(2, 12, (0, 255, 0))
		
		a4FractionColour1 = FractionColour(19, 24, (255, 255, 255))
		a4FractionColour2 = FractionColour(7, 20, (255, 255, 255))
		a4FractionColour3 = FractionColour(10, 12, (255, 255, 255))
		
		problems4 = Problems([q4FractionColour1, q4FractionColour2], [a4FractionColour1, a4FractionColour2, a4FractionColour3], 0)
		self.problems2_3.append(problems4)
		#5
		q5FractionColour1 = FractionColour(1, 6, (255, 0, 0))
		q5FractionColour2 = FractionColour(3, 9, (0, 255, 255))
		
		a5FractionColour1 = FractionColour(12, 18, (255, 255, 255))
		a5FractionColour2 = FractionColour(4, 9, (255, 255, 255))
		a5FractionColour3 = FractionColour(4, 18, (255, 255, 255))
		
		problems5 = Problems([q5FractionColour1, q5FractionColour2], [a5FractionColour1, a5FractionColour2, a5FractionColour3], 0)
		self.problems2_3.append(problems5)
		#6
		q6FractionColour1 = FractionColour(4, 6, (0, 255, 255))
		q6FractionColour2 = FractionColour(1, 9, (255, 0, 255))
		
		a6FractionColour1 = FractionColour(16, 18, (255, 255, 255))
		a6FractionColour2 = FractionColour(14, 18, (255, 255, 255))
		a6FractionColour3 = FractionColour(5, 15, (255, 255, 255))
		
		problems6 = Problems([q6FractionColour1, q6FractionColour2], [a6FractionColour1, a6FractionColour2, a6FractionColour3], 1)
		self.problems2_3.append(problems6)
		#7
		q7FractionColour1 = FractionColour(5, 12, (0, 0, 255))
		q7FractionColour2 = FractionColour(2, 9, (255, 255, 0))
		
		a7FractionColour1 = FractionColour(20, 28, (255, 255, 255))
		a7FractionColour2 = FractionColour(21, 36, (255, 255, 255))
		a7FractionColour3 = FractionColour(23, 36, (255, 255, 255))
		
		problems7 = Problems([q7FractionColour1, q7FractionColour2], [a7FractionColour1, a7FractionColour2, a7FractionColour3], 2)
		self.problems2_3.append(problems7)
		#8
		q8FractionColour1 = FractionColour(9, 10, (0, 255, 0))
		q8FractionColour2 = FractionColour(1, 20, (255, 255, 0))
		
		a8FractionColour1 = FractionColour(19, 20, (255, 255, 255))
		a8FractionColour2 = FractionColour(10, 30, (255, 255, 255))
		a8FractionColour3 = FractionColour(8, 10, (255, 255, 255))
		
		problems8 = Problems([q8FractionColour1, q8FractionColour2], [a8FractionColour1, a8FractionColour2, a8FractionColour3], 0)
		self.problems2_3.append(problems8)
		#9
		q9FractionColour1 = FractionColour(5, 8, (0, 255, 255))
		q9FractionColour2 = FractionColour(1, 4, (0, 0, 255))
		
		a9FractionColour1 = FractionColour(6, 12, (255, 255, 255))
		a9FractionColour2 = FractionColour(7, 8, (255, 255, 255))
		a9FractionColour3 = FractionColour(6, 8, (255, 255, 255))
		
		problems9 = Problems([q9FractionColour1, q9FractionColour2], [a9FractionColour1, a9FractionColour2, a9FractionColour3], 1)
		self.problems2_3.append(problems9)
		#10
		q10FractionColour1 = FractionColour(1, 2, (0, 255, 0))
		q10FractionColour2 = FractionColour(3, 9, (255, 0, 255))
		
		a10FractionColour1 = FractionColour(4, 11, (255, 255, 255))
		a10FractionColour2 = FractionColour(7, 9, (255, 255, 255))
		a10FractionColour3 = FractionColour(15, 18, (255, 255, 255))
		
		problems10 = Problems([q10FractionColour1, q10FractionColour2], [a10FractionColour1, a10FractionColour2, a10FractionColour3], 2)
		self.problems2_3.append(problems10)
		
	
	#def make3_3Problems(self):
	
	def get2_3Problem(self):
		randomProblems = random.randrange(0,len(self.problems2_3))
		
		return self.problems2_3[randomProblems]
		
	
	#def get3_3Problem(self):
	
class Problems:

	def __init__(self, questions, answers, rightAnswer):
		self.questions = questions
		self.answers = answers
		self.rightAnswer = rightAnswer